﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using Styx.Common.Helpers;
using Styx.Helpers;
using Styx.CommonBot;
using Styx.CommonBot.Profiles;
using Styx.CommonBot.Coroutines;
using Buddy.Coroutines;
using Styx.TreeSharp;
using CommonBehaviors.Actions;





namespace ItsATrap
{
    class ItsATrap : HBPlugin
    {
        // standard plugin overrides
        public override string Name { get { return "It's a Trap - Barn Auto-Trapper"; } }
        public override string Author { get { return "Opply"; } }
        public override Version Version { get { return new Version(1, 0, 0, 0); } }
        public override string ButtonText { get { return "Settings"; } }
        public override bool WantButton { get { return true; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        private GUI gui = null;
        private bool hasTrap = false;

        public override void OnButtonPress()
        {
            gui.ShowDialog();
        }

        public ItsATrap()
        {
            gui = new GUI();
        }

        public override void OnEnable()
        {
            Log("Enabled()");
            base.OnEnable();

            gui.getMobHandler().SettingsFilePath = "Settings\\ItsATrap.txt";
            gui.getMobHandler().readFile();
        }

        public override void OnDisable()
        {
            Log("Disabled()");
            MobHandler.Instance.saveFile();

            base.OnDisable();
        }

        public WoWItem GetTrap()
        {
            hasTrap = true;
            WoWItem deadlyTrap = Me.BagItems.FirstOrDefault(h => h.Entry == 115010);
            if(deadlyTrap != null)
            {
                return deadlyTrap;
            }

            WoWItem improvedTrap = Me.BagItems.FirstOrDefault(h => h.Entry == 115009);
            if (improvedTrap != null)
            {
                return improvedTrap;
            }

            WoWItem basicTrap = Me.BagItems.FirstOrDefault(h => h.Entry == 113991);
            if (basicTrap != null)
            {
                return basicTrap;
            }
            hasTrap = false;

            Log("Could not find a Trap in your inventory");
            return null;
        }

        public override void Pulse()
        {
            if (!Me.Combat || !Me.IsAlive || Me.IsGhost || Me.IsOnTransport || Me.OnTaxi || Me.Stunned || Me.Mounted )
            {
                return;
            }
            List<int> targetList = gui.getMobHandler().getList();
            WoWUnit target = Me.CurrentTarget;

			if(target==null)
			{
				return;
			}
			
			bool shalWeTrapCurrentTarget = targetList.Contains((int)target.Entry);
			
			if(shalWeTrapCurrentTarget && target.Distance > 15 && Me.Class == WoWClass.Hunter && target.HealthPercent > 85)
			{
				WoWMovement.ClickToMove(target.Location, 10);
				Thread.Sleep(1500);
			}
			
            if (shalWeTrapCurrentTarget && Me.Combat && (target.HealthPercent < 85))
            {
				if (!target.IsDead && !target.IsPet)
				{
					WoWItem trapItem = GetTrap();
					
					if (target.HealthPercent <= 49) 
					{
						if (Me.Class == WoWClass.Hunter)
						{
							Log("I R HUNTER! Casting Distracting Shot to trap!");
							int distractingShotSpellName = 20736;
							if (Styx.CommonBot.SpellManager.CanCast(distractingShotSpellName, target))
							{
								Styx.CommonBot.SpellManager.Cast(distractingShotSpellName, target);
								Lua.DoString("/petfollow");
								Lua.DoString("/stopattack");
								WoWMovement.Move(WoWMovement.MovementDirection.Backwards, new TimeSpan(30000));
								Thread.Sleep(3000);
								WoWMovement.Move(WoWMovement.MovementDirection.Forward, new TimeSpan(10000));
								Me.ClearTarget();
								Thread.Sleep(17000);
								return;
							}
							else
							{
								return;
							}
						}
						else
						{
							target.Face();
							Log("Moving backwards to trap!");
							WoWMovement.Move(WoWMovement.MovementDirection.Backwards, new TimeSpan(30000));
							Thread.Sleep(3000);
							WoWMovement.Move(WoWMovement.MovementDirection.Forward, new TimeSpan(10000));
							if (!target.IsWithinMeleeRange) 
							{ 
								Me.ClearTarget();
								Thread.Sleep(12000); 
								return;
							}
						}
					}
					if (trapItem != null && trapItem.Cooldown == 0)
					{
						target.Face();
						trapItem.UseContainerItem();
						Log(trapItem.Name + "thrown at " + target.Name + "!");
					}
				}
            }
        }

        internal void Log(string text)
        {
            Logging.Write(String.Format("ItsATrap {0}: {1}", Version, text));
        }
    }
}

